/*
---------------------------------------
	Sufficient Contrast Functions v1.0
---------------------------------------
	Created by Matt Stow 2008
	http://www.mattstow.com
---------------------------------------
*/

function HexToR(h) {return parseInt((cutHex(h)).substring(0,2),16)}
function HexToG(h) {return parseInt((cutHex(h)).substring(2,4),16)}
function HexToB(h) {return parseInt((cutHex(h)).substring(4,6),16)}
function cutHex(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h}

function CompareColour(c1,c2,n1,n2) {
	
	var twoColours = new Array(new Array(5),new Array(5));

	twoColours[0][0] = n1;
	twoColours[1][0] = n2;

	twoColours[0][1] = c1;
	twoColours[1][1] = c2;
	
	for (i = 0; i < twoColours.length; i++) {
		twoColours[i][2] = HexToR(twoColours[i][1]);
		twoColours[i][3] = HexToG(twoColours[i][1]);
		twoColours[i][4] = HexToB(twoColours[i][1]);
		twoColours[i][5] = (((twoColours[i][2]*299) + (twoColours[i][3]*587) + (twoColours[i][4]*114)) / 1000);
	}
	
	var acceptableBrightness = 125;
	var acceptableContrast = 500;
	var brightness = Math.round(Math.abs(twoColours[0][5]-twoColours[1][5]));
	
	var contrast = 0;
	for (var i = 2; i != 5; i++) {
		contrast += Math.abs(twoColours[0][i] - twoColours[1][i]);
	}
			
	congratulations = "Congratulations!\n\nBoth colour brightness and colour difference meet the recommended standard";
	failure = "Failure!\n\nBoth colour brightness and colour difference fail to meet the recommended standard";
	warning = "Warning!\n\nEither colour brightness or colour difference fail to meet the recommended standard";
	comparison = "\n\n" + twoColours[0][0] + " - " + twoColours[0][1].toUpperCase() + "\n" + twoColours[1][0] + " - " + twoColours[1][1].toUpperCase() + "\n\nBrightness: " + brightness + " (" + acceptableBrightness + "+ required)" + "\nDifference: " + contrast + " (" + acceptableContrast + "+ required)";
	
	if ((brightness >= acceptableBrightness) && (contrast >= acceptableContrast)) {
		alert(congratulations + comparison);
	}
	else if ((brightness < acceptableBrightness) && (contrast <= acceptableContrast)) {
		alert(failure + comparison);
	}
	else {
		alert(warning + comparison);
	}
	
}